buildrootschalter/package/dropbear/S50dropbear

44 lines
699 B
Plaintext
Raw Normal View History

#!/bin/sh
#
# Starts dropbear sshd.
#
dropbear: add support for custom arguments through config file The default port 22 used by dropbear for its SSH connections is not always desired. Dropbear accepts an option '-p' to set the port, but doing this was not possible from the buildroot-provided init script. One way to fix this is by adding a custom S50dropbear in a project-specific rootfs overlay. However, this approach has the big disadvantage that bug fixes or improvements in the default init script (i.e. in newer buildroot releases) are not available (unless you manually port these changes each time you upgrade buildroot). Another solution is to modify the default init script from a project-specific post-build script. However, this is fragile because you'd have to sed some line but this line may change in later buildroot releases. Yet another solution is to change the default port at build time, by patching the options.h header file in the dropbear sources. This was proposed with a patch [1] before, but not accepted. This patch implements another solution, hinted from the discussion in [1]: the default init script now sources a config file /etc/default/dropbear, in which the user can set the variable DROPBEAR_ARGS. This is similar to the S81named init script in the bind package. The config file would be added to a project-specific rootfs overlay, a custom skeleton, or created from a post-build script. This approach has the advantage of being simple and non-intrusive, without any code duplication or fragile script modifications. [1] http://lists.busybox.net/pipermail/buildroot/2013-November/083165.html Signed-off-by: Thomas De Schampheleire <thomas.de.schampheleire@gmail.com> Reviewed-by: "Yann E. MORIN" <yann.morin.1998@free.fr> Signed-off-by: Thomas Petazzoni <thomas.petazzoni@free-electrons.com>
2014-01-02 13:34:42 +01:00
# Allow a few customizations from a config file
test -r /etc/default/dropbear && . /etc/default/dropbear
start() {
dropbear: add support for custom arguments through config file The default port 22 used by dropbear for its SSH connections is not always desired. Dropbear accepts an option '-p' to set the port, but doing this was not possible from the buildroot-provided init script. One way to fix this is by adding a custom S50dropbear in a project-specific rootfs overlay. However, this approach has the big disadvantage that bug fixes or improvements in the default init script (i.e. in newer buildroot releases) are not available (unless you manually port these changes each time you upgrade buildroot). Another solution is to modify the default init script from a project-specific post-build script. However, this is fragile because you'd have to sed some line but this line may change in later buildroot releases. Yet another solution is to change the default port at build time, by patching the options.h header file in the dropbear sources. This was proposed with a patch [1] before, but not accepted. This patch implements another solution, hinted from the discussion in [1]: the default init script now sources a config file /etc/default/dropbear, in which the user can set the variable DROPBEAR_ARGS. This is similar to the S81named init script in the bind package. The config file would be added to a project-specific rootfs overlay, a custom skeleton, or created from a post-build script. This approach has the advantage of being simple and non-intrusive, without any code duplication or fragile script modifications. [1] http://lists.busybox.net/pipermail/buildroot/2013-November/083165.html Signed-off-by: Thomas De Schampheleire <thomas.de.schampheleire@gmail.com> Reviewed-by: "Yann E. MORIN" <yann.morin.1998@free.fr> Signed-off-by: Thomas Petazzoni <thomas.petazzoni@free-electrons.com>
2014-01-02 13:34:42 +01:00
DROPBEAR_ARGS="$DROPBEAR_ARGS -R"
echo -n "Starting dropbear sshd: "
umask 077
dropbear: add support for custom arguments through config file The default port 22 used by dropbear for its SSH connections is not always desired. Dropbear accepts an option '-p' to set the port, but doing this was not possible from the buildroot-provided init script. One way to fix this is by adding a custom S50dropbear in a project-specific rootfs overlay. However, this approach has the big disadvantage that bug fixes or improvements in the default init script (i.e. in newer buildroot releases) are not available (unless you manually port these changes each time you upgrade buildroot). Another solution is to modify the default init script from a project-specific post-build script. However, this is fragile because you'd have to sed some line but this line may change in later buildroot releases. Yet another solution is to change the default port at build time, by patching the options.h header file in the dropbear sources. This was proposed with a patch [1] before, but not accepted. This patch implements another solution, hinted from the discussion in [1]: the default init script now sources a config file /etc/default/dropbear, in which the user can set the variable DROPBEAR_ARGS. This is similar to the S81named init script in the bind package. The config file would be added to a project-specific rootfs overlay, a custom skeleton, or created from a post-build script. This approach has the advantage of being simple and non-intrusive, without any code duplication or fragile script modifications. [1] http://lists.busybox.net/pipermail/buildroot/2013-November/083165.html Signed-off-by: Thomas De Schampheleire <thomas.de.schampheleire@gmail.com> Reviewed-by: "Yann E. MORIN" <yann.morin.1998@free.fr> Signed-off-by: Thomas Petazzoni <thomas.petazzoni@free-electrons.com>
2014-01-02 13:34:42 +01:00
start-stop-daemon -S -q -p /var/run/dropbear.pid \
--exec /usr/sbin/dropbear -- $DROPBEAR_ARGS
[ $? == 0 ] && echo "OK" || echo "FAIL"
}
stop() {
echo -n "Stopping dropbear sshd: "
start-stop-daemon -K -q -p /var/run/dropbear.pid
[ $? == 0 ] && echo "OK" || echo "FAIL"
}
restart() {
stop
start
}
case "$1" in
start)
start
;;
stop)
stop
;;
restart|reload)
restart
;;
*)
echo "Usage: $0 {start|stop|restart}"
exit 1
esac
exit $?